Bug 486977 - Review Request: gnu-free-fonts
Review Request: gnu-free-fonts
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Gwyn Ciesla
Fedora Extras Quality Assurance
:
: 479238 (view as bug list)
Depends On: 212079
Blocks: 477336 479238
  Show dependency treegraph
 
Reported: 2009-02-23 10:01 EST by Gwyn Ciesla
Modified: 2010-08-13 13:26 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-03-24 14:30:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
nicolas.mailhot: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Comment 1 Nicolas Mailhot 2009-03-02 17:18:04 EST
Thank you very much for working on this. Here is a first review pass:

1. FPC and FESCO have decided %global was preferred over %define. The changes are in fontpackages 1.20, please apply them
http://fedoraproject.org/wiki/PackagingDrafts/global_preferred_over_define

2. Please try to keep the same declaration order as the templates, that makes diffing & reviewing easier

3. Please do not make a metapackage of the main package, if you need a metapackage for upgrade paths create a -compat subpackage that we'll be able to kill at F12 time

http://fedoraproject.org/wiki/Upgrade_paths_%E2%80%94_renaming_or_splitting_packages#Can.27t_I_use_my_old_package_name_instead_of_a_-compat_subpackage.3F

vera, mgopen, dejavu, liberation, etc all use this proven pattern

4. you can probably drop the
Obsoletes: freefont-ttf < %{version}-%{release}
freefont has been named freefont in Fedora for quite a long time

5. In rawhide you can drop the
Group:    User Interface/X
declarations in subpackages

6. use the
%package -n %{fontname}-<FAMILY>-fonts
%description -n %{fontname}-<FAMILY>-fonts
%_font_pkg -n <FAMILY> -f %{fontconf}-<FAMILY>.conf <NAME>*.ttf

which is documented in the templates if you want stuff to actually work

7. put doc in the common package, that's one of its main uses

8. BuildRequire fontforge

9. You'll likely hit
http://www.redhat.com/archives/fedora-fonts-list/2009-February/msg00076.html
too

10. Please add fontconfig rules to each font subpackages. In your case that's probably just taking the
/usr/share/fontconfig/templates/basic-font-template.conf
template and filling in font names

11. Please also make sure you've not forgotten a step in
http://fedoraproject.org/wiki/Upgrade_paths_%E2%80%94_renaming_or_splitting_packages#Source_package_naming_changes

That's all I see right now, I may have missed something else, multi-font packages can be trickier than mono-font ones. But first fix this please
Comment 2 Gwyn Ciesla 2009-03-05 11:55:23 EST
Corrected all but 9.  Can't test if 9 is needed in rawhide as mock builds are failing at the yum step with 404s, even with a fresh root cache.  Probably a temporary issue.

rel-eng ticket: https://fedorahosted.org/fedora-infrastructure/ticket/1225

Otherwise I *think * I hit all your points.

SPEC: http://zanoni.jcomserv.net/fedora/gnu-free-fonts/gnu-free-fonts.spec
SRPM:
http://zanoni.jcomserv.net/fedora/gnu-free-fonts/gnu-free-fonts-20090104-4.fc10.src.rpm
Comment 4 Nicolas Mailhot 2009-03-05 15:13:58 EST
We're getting there :)

1. you still have at least one %define in common_desc (probably did not notice it because you've reordered the template)

2.you still have a needless group declaration in your common package

3. you should simplify your subpackage names (for example use %{fontname}-mono-fonts instead of %{fontname}-freemono-fonts). Repeating the project name does not really help users.

4. you need to drop
Requires:  gnu-free-fonts-freemono-fonts = %{version}-%{release}
Requires:  gnu-free-fonts-freesans-fonts = %{version}-%{release}
Requires:  gnu-free-fonts-freeserif-fonts = %{version}-%{release}

Obsoletes: freefont < 20090104-2

from your main package

5. you probably don't need to obsolete package names that were never pushed to user systems, this obsolete data will never be used

6. you don't need
%dir %{_fontdir}
in your common package

7. you can unroll the for loop, but if you do so make sure you don't reference the for variable anymore

8. your fontconfig rule filenames need to start with a number to work (in your case 60 is probably fine, see /usr/share/fontconfig/templates/fontconfig-priorities.txt)

9. your fontconfig rules won't work if you just put the font name everywhere blindly. See /usr/share/fontconfig/templates/fontconfig-generics.txt and  /usr/share/fontconfig/templates/basic-font-template.txt
Comment 6 Jens Petersen 2009-03-05 19:12:09 EST
*** Bug 479238 has been marked as a duplicate of this bug. ***
Comment 7 Jens Petersen 2009-03-05 19:42:05 EST
(In reply to comment #4)
> 4. you need to drop
> Requires:  gnu-free-fonts-freemono-fonts = %{version}-%{release}
> Requires:  gnu-free-fonts-freesans-fonts = %{version}-%{release}
> Requires:  gnu-free-fonts-freeserif-fonts = %{version}-%{release}
> from your main package

But they should be moved to the compat package.

> 5. you probably don't need to obsolete package names that were never pushed to
> user systems, this obsolete data will never be used

Right, I think you can drop "Obsoletes: gnu-free-fonts < 20090104-4" from compat too.

Otherwise it looks pretty good to me.
Comment 9 Nicolas Mailhot 2009-03-14 14:52:33 EDT
Another pass:

1. you're not defining fontname as intended by the template and as a result you have weird package names such as gnu-free-fonts-mono-fonts instead of a nice gnu-free-mono-fonts
fontname shoud not have the same value as name or we would not bother with it

2. your fontconfig symlinks are broken
lrw-r--r--    1 root    root                       52 mars 14 19:35 /etc/fonts/conf.d/60-gnu-free-fonts-mono.conf -> /usr/share/fontconfig/conf.avail/gnu-free-fonts-m
ono
-rw-r--r--    1 root    root                      334 mars  5 21:46 /usr/share/fontconfig/conf.avail/60-gnu-free-fonts-mono.conf

It would probably simpler if you just used the symlinking logic proposed by the template

3. Your compat package
Requires:  gnu-free-fonts-freemono-fonts = %{version}-%{release}
Requires:  gnu-free-fonts-freesans-fonts = %{version}-%{release}
Requires:  gnu-free-fonts-freeserif-fonts = %{version}-%{release}
But your srpm generates subpackages named differently, so it won't work

4. rpmlint points some minor problems
W: spelling-error-in-description compatability compatibility
E: description-line-too-long This package only exists to help transition pre 20090104-4 freefotn users to the new\
W: summary-not-capitalized freefont compatibility package
Comment 10 Gwyn Ciesla 2009-03-18 09:17:53 EDT
Fixed 1, 2, 3, and 4.

SPEC: http://zanoni.jcomserv.net/fedora/gnu-free-fonts/gnu-free-fonts.spec
SRPM:
http://zanoni.jcomserv.net/fedora/gnu-free-fonts/gnu-free-fonts-20090104-8.fc10.src.rpm 

Re the symlinks, why do we use absolute and not relative symlinks in font pacakges?
Comment 11 Nicolas Mailhot 2009-03-18 09:34:32 EDT
(In reply to comment #10)

> Re the symlinks, why do we use absolute and not relative symlinks in font
> pacakges?  

Because it's simpler and FPC already decided the rpmlint warning about absolute symlinks was trashable. But they're ok not requiring our rpmlint packager to remove it and having people waste their time in reviews over it.
Comment 12 Nicolas Mailhot 2009-03-19 14:31:17 EDT
Ok, you're producing the right package names at last

But you compat package is still requiring package names that do not match what you build

And if you look in /usr/share/fontconfig/conf.avail/ you'll see the files you pack do not match what other packages do.
Comment 13 Gwyn Ciesla 2009-03-19 15:08:04 EDT
<facepalm>  I fixed the Requires.  I see nothing in /u/s/fc/conf.avail, do you mean /etc/fonts/conf.avail?  If so, my files resemble those, but are not so complex.  They're a straight filling in of a template.  If they need enhancement or alteration, I'm not sure where to go next with them, as I have only a vague idea what these files do, and not much idea *how*.
Comment 14 Nicolas Mailhot 2009-03-19 16:36:24 EDT
Sorry, I was not clear. -ENOSLEEP

Your spec produces dangling symlinks that won't work, such as

/etc/fonts/conf.d/60-gnu-free-sans.conf -> /usr/share/fontconfig/conf.avail/gnu-free-sans
Comment 16 Nicolas Mailhot 2009-03-21 05:50:58 EDT
And now you have another kind of dangling symlink

/etc/fonts/conf.d/60-gnu-free-mono.conf -> /usr/share/fontconfig/conf.avail/gnu-free-mono.conf

Would it be so hard to just use the pattern documented in the official spec templates instead of exploring every possible broken alternative? This is getting really old.
Comment 17 Gwyn Ciesla 2009-03-23 11:34:08 EDT
SPEC: http://zanoni.jcomserv.net/fedora/gnu-free-fonts/gnu-free-fonts.spec
SRPM:
http://zanoni.jcomserv.net/fedora/gnu-free-fonts/gnu-free-fonts-20090104-10.fc10.src.rpm 

Fixed, and I moved closer to the template.  I agree that this is getting old, but I'm learning font packaging as I go.
Comment 18 Nicolas Mailhot 2009-03-23 17:58:38 EDT
Ok, this one looks good. Can't test it fully because of bug #491764 but it passes my other tests

♼♼♼ APPROVED ♼♼♼

Please make sure the other steps in
http://fedoraproject.org/wiki/Upgrade_paths_%E2%80%94_renaming_or_splitting_packages#Source_package_naming_changes

are taken care of. Also I think you deserve at least co-maintainership of the new package. Congratulations

This is about the worst-case font packaging scenario you can get in Fedora so if you don't forget what you've learnt here you should be able to package about any font now.
Comment 19 Orion Poplawski 2009-03-23 18:03:52 EDT
Oh, I'd love to give this package up to whoever wants it.
Comment 20 Gwyn Ciesla 2009-03-24 08:27:59 EDT
Awesome, thanks for you review and font education.  Orion, I'll take over the new package.  You want co-maintainership?


New Package CVS Request
=======================
Package Name: gnu-free-fonts
Short Description: Free UCS Outline Fonts
Owners: limb
Branches: 
InitialCC:
Comment 21 Orion Poplawski 2009-03-24 09:31:05 EDT
(In reply to comment #20)
> Awesome, thanks for you review and font education.  Orion, I'll take over the
> new package.  You want co-maintainership?

Works for me.

New Package CVS Request

======================
Package Name: gnu-free-fonts
Short Description: Free UCS Outline Fonts
Owners: limb orion
Branches: 
InitialCC:
Comment 22 Kevin Fenzi 2009-03-24 13:34:21 EDT
cvs done.
Comment 23 Gwyn Ciesla 2009-03-24 14:30:52 EDT
Imported and built.  Bugs for known dependant packages updated.  freefont EOL ticket updated.

Thanks all!
Comment 24 Orion Poplawski 2010-08-13 12:30:53 EDT
We need an EL6 branch for this.

Package Change Request
======================
Package Name: gnu-free-fonts
New Branches: Free UCS Outline Fonts
Owners: limb orion
InitialCC:
Comment 25 Jason Tibbitts 2010-08-13 13:22:56 EDT
Erm, "Free UCS Outline Fonts" is four not-valid branches.  I changed it to el6
for you.

Git done (by process-git-requests).
Comment 26 Orion Poplawski 2010-08-13 13:26:39 EDT
Ah, sorry about that.  Thanks.

Note You need to log in before you can comment on or make changes to this bug.